// readrdm script comment

int queued_message_pid = 0x0020;
int product_detail_id_list_pid = 0x0070;
int device_model_description_pid = 0x0080;
int manufacturer_label_pid = 0x0081;
int device_label_pid = 0x0082;
int factory_defaults_pid = 0x0090;
int language_capabilities_pid = 0x00a0;
int language_pid = 0x00b0;
int boot_software_version_id_pid = 0x00c1;
int boot_software_version_label_pid = 0x00c2;
int dmx_personality_pid = 0x00e0;
int dmx_personality_description_pid = 0x00e1;
int slot_info_pid = 0x0120;
int slot_description_pid = 0x0121;
int sensor_definition_pid = 0x0200;
int sensor_value_pid = 0x0201;
int record_sensors_pid = 0x0202;
int device_hours_pid = 0x0400;
int real_time_clock_pid = 0x0603;
int reset_device_pid = 0x1001;
int power_state_pid = 0x1010;
int identify_mode_pid = 0x1040;
int software_version_label_pid = 0x00c0;
int dmx_start_address_pid = 0x00f0;

int controllerCount = GetRdmControllerCount();

int devicesList = CreateRdmDeviceList();
int deviceCount = GetRdmDeviceCount(devicesList);
printf("\n\n###################################################################\n");
printf("                            RDM STATUS\n");
printf("###################################################################\n\n");
printf("Controller Count: %d\n", controllerCount);
printf("Device Count: %d\n\n", deviceCount);

int i;
int j;
string deviceId;
string sensorDesc;
int isOnline;
int hasDeviceInfo;
int deviceFootprint;
int deviceSensorCount;
int subDeviceCount;
int DeviceIsComplete;
int sensorNormalMaximum;
int sensorNormalMinimum;
int sensorRangeMaximum;
int sensorRangeMinimum;
int sensorValue;
string sensorNormalMaximumText;
string sensorNormalMinimumText;
string sensorRangeMaximumText;
string sensorRangeMinimumText;
string sensorValueText;

string queued_message_text;
int queued_message_value;
string product_detail_id_list_text;
int product_detail_id_list_value;
string device_model_description_text;
int device_model_description_value;
string manufacturer_label_text;
int manufacturer_label_value;
string device_label_text;
int device_label_value;
string factory_defaults_text;
int factory_defaults_value;
string language_capabilities_text;
int language_capabilities_value;
string language_text;
int language_value;
string boot_software_version_id_text;
int boot_software_version_id_value;
string boot_software_version_label_text;
int boot_software_version_label_value;
string dmx_personality_text;
int dmx_personality_value;
string dmx_personality_description_text;
int dmx_personality_description_value;
string slot_info_text;
int slot_info_value;
string slot_description_text;
int slot_description_value;
string sensor_definition_text;
int sensor_definition_value;
string sensor_value_text;
int sensor_value_value;
string record_sensors_text;
int record_sensors_value;
string device_hours_text;
int device_hours_value;
string real_time_clock_text;
int real_time_clock_value;
string reset_device_text;
int reset_device_value;
string power_state_text;
int power_state_value;
string identify_mode_text;
int identify_mode_value;
int software_version_label_value;
string software_version_label_text;
int dmx_start_address_value;
string dmx_start_address_text;

for (i = 0; i < deviceCount; i++)
{
    printf("------------------------  DEVICE %d  -----------------------\n", i);
    deviceId = GetRdmDeviceId(devicesList, i);
    isOnline = RdmDeviceIsOnline(deviceId);
    hasDeviceInfo = RdmDeviceHasDeviceInfo(deviceId);

    printf("|ID: %s\n", deviceId);
    printf("|isOnline: %d\n", isOnline);
    printf("|hasDeviceInfo: %d\n", hasDeviceInfo);

    if (hasDeviceInfo)
    {
        deviceFootprint = GetRdmDeviceFootprint(deviceId);
        deviceSensorCount = GetRdmDeviceSensorCount(deviceId);
        subDeviceCount = GetRdmSubDeviceCount(deviceId);
        DeviceIsComplete = RdmDeviceIsComplete(deviceId);
        printf("|deviceFootprint: %d\n", deviceFootprint);
        printf("|deviceSensorCount: %d\n", deviceSensorCount);
        printf("|subDeviceCount: %d\n", subDeviceCount);
        printf("|DeviceIsComplete: %d\n", DeviceIsComplete);

        dmx_start_address_value = GetRdmParameterValue(deviceId, dmx_start_address_pid);
        dmx_start_address_text = GetRdmParameterText(deviceId, dmx_start_address_pid);
        software_version_label_value = GetRdmParameterValue(deviceId, software_version_label_pid);
        software_version_label_text = GetRdmParameterText(deviceId, software_version_label_pid);
        queued_message_value = GetRdmParameterValue(deviceId, queued_message_pid);
        queued_message_text = GetRdmParameterText(deviceId, queued_message_pid);
        queued_message_value = GetRdmParameterValue(deviceId, queued_message_pid);
        queued_message_text = GetRdmParameterText(deviceId, queued_message_pid);
        queued_message_value = GetRdmParameterValue(deviceId, queued_message_pid);
        product_detail_id_list_text = GetRdmParameterText(deviceId, product_detail_id_list_pid);
        product_detail_id_list_value = GetRdmParameterValue(deviceId, product_detail_id_list_pid);
        device_model_description_text = GetRdmParameterText(deviceId, device_model_description_pid);
        device_model_description_value = GetRdmParameterValue(deviceId, device_model_description_pid);
        manufacturer_label_text = GetRdmParameterText(deviceId, manufacturer_label_pid);
        manufacturer_label_value = GetRdmParameterValue(deviceId, manufacturer_label_pid);
        device_label_text = GetRdmParameterText(deviceId, device_label_pid);
        device_label_value = GetRdmParameterValue(deviceId, device_label_pid);
        factory_defaults_text = GetRdmParameterText(deviceId, factory_defaults_pid);
        factory_defaults_value = GetRdmParameterValue(deviceId, factory_defaults_pid);
        language_capabilities_text = GetRdmParameterText(deviceId, language_capabilities_pid);
        language_capabilities_value = GetRdmParameterValue(deviceId, language_capabilities_pid);
        language_text = GetRdmParameterText(deviceId, language_pid);
        language_value = GetRdmParameterValue(deviceId, language_pid);
        boot_software_version_id_text = GetRdmParameterText(deviceId, boot_software_version_id_pid);
        boot_software_version_id_value = GetRdmParameterValue(deviceId, boot_software_version_id_pid);
        boot_software_version_label_text = GetRdmParameterText(deviceId, boot_software_version_label_pid);
        boot_software_version_label_value = GetRdmParameterValue(deviceId, boot_software_version_label_pid);
        dmx_personality_text = GetRdmParameterText(deviceId, dmx_personality_pid);
        dmx_personality_value = GetRdmParameterValue(deviceId, dmx_personality_pid);
        dmx_personality_description_text = GetRdmParameterText(deviceId, dmx_personality_description_pid);
        dmx_personality_description_value = GetRdmParameterValue(deviceId, dmx_personality_description_pid);
        slot_info_text = GetRdmParameterText(deviceId, slot_info_pid);
        slot_info_value = GetRdmParameterValue(deviceId, slot_info_pid);
        slot_description_text = GetRdmParameterText(deviceId, slot_description_pid);
        slot_description_value = GetRdmParameterValue(deviceId, slot_description_pid);
        sensor_definition_text = GetRdmParameterText(deviceId, sensor_definition_pid);
        sensor_definition_value = GetRdmParameterValue(deviceId, sensor_definition_pid);
        sensor_value_text = GetRdmParameterText(deviceId, sensor_value_pid);
        sensor_value_value = GetRdmParameterValue(deviceId, sensor_value_pid);
        record_sensors_text = GetRdmParameterText(deviceId, record_sensors_pid);
        record_sensors_value = GetRdmParameterValue(deviceId, record_sensors_pid);
        device_hours_text = GetRdmParameterText(deviceId, device_hours_pid);
        device_hours_value = GetRdmParameterValue(deviceId, device_hours_pid);
        real_time_clock_text = GetRdmParameterText(deviceId, real_time_clock_pid);
        real_time_clock_value = GetRdmParameterValue(deviceId, real_time_clock_pid);
        reset_device_text = GetRdmParameterText(deviceId, reset_device_pid);
        reset_device_value = GetRdmParameterValue(deviceId, reset_device_pid);
        power_state_text = GetRdmParameterText(deviceId, power_state_pid);
        power_state_value = GetRdmParameterValue(deviceId, power_state_pid);
        identify_mode_text = GetRdmParameterText(deviceId, identify_mode_pid);
        identify_mode_value = GetRdmParameterValue(deviceId, identify_mode_pid);

        // printf("|queued_message_text: %s\n", queued_message_text);
        // printf("|queued_message_value: %d\n", queued_message_value);
        // printf("|product_detail_id_list_text: %s\n", product_detail_id_list_text);
        // printf("|product_detail_id_list_value: %d\n", product_detail_id_list_value);
        printf("|device_model_description_text: %s\n", device_model_description_text);
        // printf("|device_model_description_value: %d\n", device_model_description_value);
        printf("|manufacturer_label_text: %s\n", manufacturer_label_text);
        // printf("|manufacturer_label_value: %d\n", manufacturer_label_value);
        printf("|device_label_text: %s\n", device_label_text);
        // printf("|device_label_value: %d\n", device_label_value);
        printf("|factory_defaults_text: %s\n", factory_defaults_text);
        printf("|factory_defaults_value: %d\n", factory_defaults_value);
        // printf("|language_capabilities_text: %s\n", language_capabilities_text);
        // printf("|language_capabilities_value: %d\n", language_capabilities_value);
        // printf("|language_text: %s\n", language_text);
        // printf("|language_value: %d\n", language_value);
        printf("|boot_software_version_id_text: %s\n", boot_software_version_id_text);
        // printf("|boot_software_version_id_value: %d\n", boot_software_version_id_value);
        printf("|boot_software_version_label_text: %s\n", boot_software_version_label_text);
        // printf("|boot_software_version_label_value: %d\n", boot_software_version_label_value);
        // printf("|dmx_personality_text: %s\n", dmx_personality_text);
        printf("|dmx_personality_value: %d\n", dmx_personality_value);
        printf("|dmx_personality_description_text: %s\n", dmx_personality_description_text);
        // printf("|dmx_personality_description_value: %d\n", dmx_personality_description_value);
        printf("|slot_info_text: %s\n", slot_info_text);
        printf("|slot_info_value: %d\n", slot_info_value);
        printf("|slot_description_text: %s\n", slot_description_text);
        // printf("|slot_description_value: %d\n", slot_description_value);
        printf("|sensor_definition_text: %s\n", sensor_definition_text);
        printf("|sensor_definition_value: %d\n", sensor_definition_value);
        printf("|sensor_value_text: %s\n", sensor_value_text);
        printf("|sensor_value_value: %d\n", sensor_value_value);
        // printf("|record_sensors_text: %s\n", record_sensors_text);
        // printf("|record_sensors_value: %d\n", record_sensors_value);
        // printf("|device_hours_text: %s\n", device_hours_text);
        printf("|device_hours_value: %d\n", device_hours_value);
        printf("|real_time_clock_text: %s\n", real_time_clock_text);
        printf("|real_time_clock_value: %d\n", real_time_clock_value);
        printf("|reset_device_text: %s\n", reset_device_text);
        printf("|reset_device_value: %d\n", reset_device_value);
        printf("|power_state_text: %s\n", power_state_text);
        printf("|power_state_value: %d\n", power_state_value);
        printf("|identify_mode_text: %s\n", identify_mode_text);
        printf("|identify_mode_value: %d\n", identify_mode_value);
        printf("|dmx_start_address: %d\n", dmx_start_address_value);
        printf("|software_version_label_text: %s\n", software_version_label_text);

        for (j = 0; j < deviceSensorCount; j++)
        {
            sensorDesc = GetRdmSensorDesc(deviceId, j);
            sensorNormalMaximum = GetRdmSensorNormalMaximum(deviceId, j);
            sensorNormalMaximumText = GetRdmSensorNormalMaximumText(deviceId, j);
            sensorNormalMinimum = GetRdmSensorNormalMinimum(deviceId, j);
            sensorNormalMinimumText = GetRdmSensorNormalMinimumText(deviceId, j);
            sensorRangeMaximum = GetRdmSensorRangeMaximum(deviceId, j);
            sensorRangeMaximumText = GetRdmSensorRangeMaximumText(deviceId, j);
            sensorRangeMinimum = GetRdmSensorRangeMinimum(deviceId, j);
            sensorRangeMinimumText = GetRdmSensorRangeMinimumText(deviceId, j);
            sensorValue = GetRdmSensorValue(deviceId, j);
            sensorValueText = GetRdmSensorValueText(deviceId, j);

            printf("    | SENSOR %d: %s\n", j, sensorDesc);
            printf("          | NormalMaximum: %d\n", sensorNormalMaximum);
            printf("          | NormalMaximumText: %s\n", sensorNormalMaximumText);
            printf("          | NormalMinimum: %d\n", sensorNormalMinimum);
            printf("          | NormalMinimumText: %s\n", sensorNormalMinimumText);
            printf("          | RangeMaximum: %d\n", sensorRangeMaximum);
            printf("          | RangeMaximumText: %s\n", sensorRangeMaximumText);
            printf("          | RangeMinimum: %d\n", sensorRangeMinimum);
            printf("          | RangeMinimumText: %s\n", sensorRangeMinimumText);
            printf("          | Value: %d\n", sensorValue);
            printf("          | ValueText: %s\n", sensorValueText);
        }
    }
}

DestroyRdmDeviceList(devicesList);
